=== debian/changelog ===
openjdk-25 (25.0.1+8-1) unstable; urgency=medium

  * OpenJDK 25.0.1 release, build 8.
    - CVEs:
      + CVE-2025-53057, 8360937: Enhance certificate handling.
      + CVE-2025-53066, 8356294: Enhance Path Factories.
      + CVE-2025-61748, 8359454: Enhance String handling.

  [ Vladimir Petko ]
  * d/s/lintian-overrides: Override false positive nproc warning.
  * d/{JB-doc.overrides.in, JB-jre-headless.overrides.in}: Add override for
    old FSF copyright address.
  * d/JB-jvmci-jdk.overrides.in: Update overrides for jvmci package.
  * d/t/problems.csv: DocRootDirPermissionsTest.java - Fix typo in
    the test name.
  * d/t/problems.csv: Synchronize problem list.
  * d/t/dependencies.sh: Relax test assertion for PC/SC library.
  * d/rules: Prefer openjdk-25 for bootstrap.
  * d/control: Regenerate.
  * d/p/jdk-8369450.patch: Fix ftbfs due to rust-coreutils date. LP: #2127120.
  * Security Manager was removed in -25, so the JDK image no longer has
    default.policy and java.policy.
  * jaxp-strict.properties.template was moved by d/rules to
    jaxp-strict.properties, but we still created symlink to
    jaxp-strict.properties.template.  Replace mv with cp so that link
    to jaxp-strict.properties.template is not broken.
  * d/rules: Run jtreg autopkgtests only on jtreg architectures.
  * d/t/{hotspot-autopkgtest.in, jdk-autopkgtest.in}: Skip tests
    that require a large amount of memory.
  * d/t/{control,hotspot-autopkgtest.sh, jdk-autopkgtest.sh}:
    Regenerate.
  * d/p/jdk-8370049-proposed.patch: s390x G1 barrier compare and exchange
    operation should update output parameter instead of input.  LP: #2127750.

  [ Matthias Klose ]
  * d/rules: Let the install target depend on the build target.
    Closes: #1105520.
  * Update the location of the upstream VCS.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 22 Oct 2025 12:19:10 +0200
